//+-----------------------------------------------------------------
//|                                                Yard-Soft_v01.mq4      
//|                                              as Vuki 
//|                                                  f_kombi@mail.ru 
//+-----------------------------------------------------------------
//|            2        
//|          
//+-----------------------------------------------------------------
#property copyright "  as Vuki"
#property link      "f_kombi@mail.ru"
#property show_inputs

extern int       BarNumber = 500; // -   
extern int       FastMAperiod = 5; //   
extern int       FastMAtype   = MODE_EMA;  //   
extern int       FastMAprice  = PRICE_TYPICAL;  //   
extern int       SlowMAperiod = 7;
extern int       SlowMAtype   = MODE_EMA;
extern int       SlowMAprice  = PRICE_TYPICAL;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start() {
  int i,j,Up,Dn;
  double ma5, ma8, ma5_, ma8_;
  double Delta,DeltaUp, DeltaDn;
  double MaxDeltaUp, MaxDeltaDn;

  double Cross_i, Cross_i1;
  int Index[100];
  
  Up = 0;
  Dn = 0;
  j = 0;
  for (i=0; i<BarNumber; i++) {
    ma5 = iMA(NULL,0,FastMAperiod,0,FastMAtype,FastMAprice,i);
    ma8 = iMA(NULL,0,SlowMAperiod,2,SlowMAtype,SlowMAprice,i);
    ma5_ = iMA(NULL,0,FastMAperiod,0,FastMAtype,FastMAprice,i+1);
    ma8_ = iMA(NULL,0,SlowMAperiod,2,SlowMAtype,SlowMAprice,i+1);
    if(ma5 > ma8 && ma5_ < ma8_) {Up++;j++;Index[j]=i;}
    if(ma5 < ma8 && ma5_ > ma8_) {Dn++;j++;Index[j]=i;}
  }
  DeltaDn = 0;
  DeltaUp = 0;
  MaxDeltaUp = 0;
  MaxDeltaDn = 0;
  for(i=1; i<=j-1; i++) {
    ma5 = iMA(NULL,0,FastMAperiod,0,FastMAtype,FastMAprice,Index[i]);
    ma8 = iMA(NULL,0,SlowMAperiod,2,SlowMAtype,SlowMAprice,Index[i]);
    ma5_ = iMA(NULL,0,FastMAperiod,0,FastMAtype,FastMAprice,Index[i]+1);
    ma8_ = iMA(NULL,0,SlowMAperiod,2,SlowMAtype,SlowMAprice,Index[i]+1);

    Cross_i = (ma5+ma8+ma5_+ma8_)/4;
    ma5 = iMA(NULL,0,FastMAperiod,0,FastMAtype,FastMAprice,Index[i+1]);
    ma8 = iMA(NULL,0,SlowMAperiod,2,SlowMAtype,SlowMAprice,Index[i+1]);
    ma5_ = iMA(NULL,0,FastMAperiod,0,FastMAtype,FastMAprice,Index[i+1]+1);
    ma8_ = iMA(NULL,0,SlowMAperiod,2,SlowMAtype,SlowMAprice,Index[i+1]+1);
    Cross_i1 = (ma5+ma8+ma5_+ma8_)/4;
    
    if(Cross_i < Cross_i1) {
      Delta = (Cross_i1/Point-Cross_i/Point);
      DeltaDn = DeltaDn + Delta;
      if(Delta > MaxDeltaDn) MaxDeltaDn = Delta;
//      Print(" i = ",i," DeltaDn = ",DeltaDn);
    }  
    if(Cross_i > Cross_i1) {
      Delta = (Cross_i/Point-Cross_i1/Point);
      DeltaUp = DeltaUp + Delta;
      if(Delta > MaxDeltaUp) MaxDeltaUp = Delta;
//      Print(" i = ",i," DeltaUp = ",DeltaUp);
    }  
  }
  DeltaUp = DeltaUp/Up;
  DeltaDn = DeltaDn/Dn;
    
  Comment("  -> ",(Up+Dn),"\n",
          "   ,  -> ",MathRound((DeltaUp)+(DeltaDn))/2,"\n",
          "   -> ",BarNumber/(Up+Dn),"\n"
           );
  return;
}
//+------------------------------------------------------------------+

